<?php
/************************************************************************
 * MXChange v0.2.1                                    Start: 10/10/2003 *
 * ===============                              Last change: 07/04/2004 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : what-config_cats.php                             *
 * -------------------------------------------------------------------- *
 * Short description : Add new categories and edit / delete existing    *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Neue Kategorien hinzufuegen und bestehende       *
 *                     editieren / loeschen                             *
 * -------------------------------------------------------------------- *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2008 by Roland Haeder                           *
 * For more information visit: http://www.mxchange.org                  *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Some security stuff...
if ((!defined('__SECURITY')) || (!IS_ADMIN())) {
	$INC = substr(dirname(__FILE__), 0, strpos(dirname(__FILE__), "/inc") + 4) . "/security.php";
	require($INC);
}

// Add description as navigation point
ADD_DESCR("admin", __FILE__);

// Init variable to avoid a notice
$CATS = "";

if (isset($_POST['add'])) {
	// Add a new category
	$result = SQL_QUERY_ESC("SELECT id FROM "._MYSQL_PREFIX."_cats WHERE cat='%s' LIMIT 1",
	 array(addslashes($_POST['catname'])), __FILE__, __LINE__);
	if (SQL_NUMROWS($result) == 0) {
		// Category does not exists, we simply add it...
		$result = SQL_QUERY_ESC("INSERT INTO "._MYSQL_PREFIX."_cats (cat, visible, sort) VALUES ('%s','%s','%s')",
		 array(addslashes($_POST['catname']), $_POST['visible'], bigintval($_POST['parent'] + 1)), __FILE__, __LINE__);
		$content = "<SPAN class=\"admin_done\">".CATEGORY_ADDED."</SPAN>";
	} else {
		// Category does already exists
		$content = "<SPAN class=\"admin_failed\">".CATEGORY_ALREADY_EXISTS."</SPAN>";
	}

	// Free memory
	SQL_FREERESULT($result);

	// Display message
	LOAD_TEMPLATE("admin_settings_saved", false, $content);
} elseif ((isset($_POST['ok'])) && (isset($_POST['id'])) && (is_array($_POST['id']))) {
	// Change or delete categories...
	$TEXT = "";
	foreach ($_POST['id'] as $id => $cat) {
		// Secure ID
		$id = bigintval($id);

		// Is the entry set?
		if (!empty($cat)) {
			switch ($_GET['do'])
			{
			case "edit": // Change categories
				$result = SQL_QUERY_ESC("UPDATE "._MYSQL_PREFIX."_cats SET cat='%s', visible='%s', sort=%s WHERE id=%s LIMIT 1",
				 array($cat, $_POST['vis'][$id], $_POST['sort'][$id], $id), __FILE__, __LINE__);
				$TEXT = CATEGORIES_SAVED;
				break;

			case "del": // Delete categories
				$result = SQL_QUERY_ESC("DELETE LOW_PRIORITY FROM "._MYSQL_PREFIX."_cats WHERE id=%s LIMIT 1",
				 array($id), __FILE__, __LINE__);
				$result = SQL_QUERY_ESC("DELETE LOW_PRIORITY FROM "._MYSQL_PREFIX."_user_cats WHERE cat_id=%s",
				 array($id), __FILE__, __LINE__);
				$TEXT = CATEGORIES_DELETED;
				break;
			}
		} else {
			// Entry not saved
			$TEXT .= sprintf(CATEGORY_NOT_SAVED, $id);
		}
	}

	if (isset($TEXT)) {
		// Display message
		LOAD_TEMPLATE("admin_settings_saved", false, $TEXT);
	}
}
 elseif ((isset($_POST['del'])) && ((SELECTION_COUNT($_POST['sel']) > 0) || (isset($_POST['sel'][0]))))
{
	// Delete categories
	$SW = 2; $OUT = "";
	foreach ($_POST['sel'] as $id => $value)
	{
		// Load data of category
		$result = SQL_QUERY_ESC("SELECT cat FROM "._MYSQL_PREFIX."_cats WHERE id=%s LIMIT 1",
		 array(bigintval($id)), __FILE__, __LINE__);
		list($cat) = SQL_FETCHROW($result);
		SQL_FREERESULT($result);

		// Prepare data for the row template
		$content = array(
			'sw'  => $SW,
			'id'  => $id,
			'cat' => $cat,
		);

		// Load row template and switch colors
		$OUT .= LOAD_TEMPLATE("admin_del_cats_row", true, $content);
		$SW = 3 - $SW;
	}
	define('__CAT_ROWS', $OUT);

	// Load main template
	LOAD_TEMPLATE("admin_del_cats");
} elseif ((isset($_POST['edit'])) && ((SELECTION_COUNT($_POST['sel']) > 0) || (isset($_POST['sel'][0])))) {
	// Edit categories
	$SW = 2; $OUT = "";
	foreach ($_POST['sel'] as $id => $value)
	{
		// Load data from the category
		$result = SQL_QUERY_ESC("SELECT cat, visible, sort FROM "._MYSQL_PREFIX."_cats WHERE id=%s LIMIT 1",
		 array(bigintval($id)), __FILE__, __LINE__);
		list($cat, $vis, $sort) = SQL_FETCHROW($result);
		SQL_FREERESULT($result);

		// Prepare data for the row template
		$content = array(
			'sw'   => $SW,
			'id'   => $id,
			'cat'  => $cat,
			'vis'  => ADD_SELECTION("yn", $vis, "vis", $id),
			'sort' => $sort,
		);

		// Load row template and switch colors
		$OUT .= LOAD_TEMPLATE("admin_edit_cats_row", true, $content);
		$SW = 3 - $SW;
	}
	define('__CAT_ROWS', $OUT);

	// Load main template
	LOAD_TEMPLATE("admin_edit_cats");
}
 else
{
	// Load all categories
	$result = SQL_QUERY("SELECT id, cat, visible, sort FROM "._MYSQL_PREFIX."_cats ORDER BY sort", __FILE__, __LINE__);
	if (SQL_NUMROWS($result) > 0)
	{
		// List already existing categories for editing
		$SW = 2; $OUT = ""; $CATS = "";
		while (list($id, $cat, $visible, $sort) = SQL_FETCHROW($result))
		{
			// Prepare data for the row template
			$content = array(
				'sw'   => $SW,
				'id'   => $id,
				'cat'  => $cat,
				'vis'  => TRANSLATE_YESNO($visible),
				'sort' => $sort,
			);

			// Put cat descriptions into variable for the selection box
			if (strlen($cat) > 20) $cat = substr($cat, 0, 17)."...";
			$CATS .= "      <OPTION value=\"".$sort."\">".$cat."</OPTION>\n";

			// Load row template and switch color
			$OUT .= LOAD_TEMPLATE("admin_config_cats_row", true, $content);
			$SW = 3 - $SW;
		}

		// Free memory
		SQL_FREERESULT($result);
		define('__CAT_ROWS', $OUT);

		// Load main template
		LOAD_TEMPLATE("admin_config_cats");
	}

	define('CATS', $CATS);

	// Form to add a new category
	LOAD_TEMPLATE("admin_add_cat");
}

//
?>
